#ifndef RANDOM_H
#define RANDOM_H

#include "stdlib.h"

static int my_rand_r(unsigned int *nextp)
{
#ifdef NO_RANDOM
  return 42;
#else
  *nextp = *nextp * 1103515245 + 12345;
  return (unsigned int)(*nextp / 65536) % 32768;
#endif
}

#define MY_RAND_MAX 32768

static double random_double(unsigned int *seed_ptr){
    double randomDouble = (double)my_rand_r(seed_ptr);
    return randomDouble/MY_RAND_MAX;
}


#endif
