#include <stdlib.h>

typedef struct {
    int size;
    int capacity;
    int * array;
} range_query_result_buffer;

range_query_result_buffer * result_empty(){
    range_query_result_buffer * res = malloc(sizeof(range_query_result_buffer));
    res->size=0;
    res->capacity=16;
    res->array = malloc(16*sizeof(int));
    return res;
}


int result_size(range_query_result_buffer * res){
    if(res == NULL){
        return 0;
    }else{
        return res->size;
    }
}

range_query_result_buffer * result_add(range_query_result_buffer * res, int new_item){
    if(res == NULL){
        res = malloc(sizeof(range_query_result_buffer));
        res->size = 0;
        res->capacity = 1;
        res->array = malloc(sizeof(int));
        return result_add(res, new_item);
    }else{
        if(res->size == res->capacity){
            int * new_array = malloc(sizeof(int) * (res->capacity *2));
            for(int i = 0; i < res->size; i++){
                new_array[i] = res->array[i];
            }
            res->array = new_array;
            res->capacity = res->capacity*2;
        }
        res->array[res->size] = new_item;
        res->size = res->size + 1;
        return res;
    }
}




int max(int m1, int m2){
    return m1 > m2 ? m1 : m2;
}

int min(int m1, int m2){
    return m1 < m2 ? m1 : m2;
}
